unit Unit1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Objgrid,  StdCtrls, Grids;
  {StdCtrls}

type
  TForm1 = class(TForm)
    Button1: TButton;
    ListBox1: TListBox;
    Button2: TButton;
    aGrid: TObjStrGrid;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure aGridOnGridButtonClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure aGridOnSelectCell(Sender: TObject; Col, Row: Longint;
  var CanSelect: Boolean);


  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
aGrid.width := 320;
aGrid.top := 134;
aGrid.left := 40;

aGrid.ComboList.addstrings(ListBox1.Items);

aGrid.EntryMode := eButtonEdit;
aGrid.ButtonCaption := 'more';


{Char case for the edit box:}
aGrid.CharCase := ecUpperCase;

aGrid.MaxLength := 5;
aGrid.Width := 500;

{Cell having an edit box and a button, just like in the
property editor.
The Edit box will have 30% of the cell, and the button will have
70%:}
aGrid.EditButtonShare := 30;

aGrid.Colcount := 6;

aGrid.CheckBoxCaption := 'Seen?';

{Values that will be stored in the grid if check/uncheck.
If these values are already copied in the grid, the check box
will be checked/unchecked accordingly.}
aGrid.UnCheckValue := 'No';
aGrid.CheckValue := 'Yes';

{Changes to the grid's font also affect the objects' fonts.
We could easily had a boolean property to control that if necessary.}
aGrid.Font.Name := 'Arial';

{aGrid.CheckBoxState := cbGrayed;}

{Title of each column, indicating the 'EntryMode' which is the
type of the object we'll see in the column.}
aGrid.cells[1,0] := 'eButtonEdit';
aGrid.cells[2,0] := 'eButton';
aGrid.cells[3,0] := 'eEdit';
aGrid.cells[4,0] := 'eCombo';
aGrid.cells[5,0] := 'eCheckBox';



end;

procedure TForm1.Button1Click(Sender: TObject);
begin
{You can make an object appear but disable it.
Here, for instance, we disable the combobox.
You can have comboboxes or edits etc... in every cell of a
column, but disable it for a specific cell.
You would have to write the code for that in the
SelectCell event handler.}
aGrid.ComboBoxEnabled := false;
end;

procedure TForm1.aGridOnGridButtonClick(Sender: TObject);
begin
{Your custom procedure on grid button click goes here}
MessageDlg('Grid but click', mtInformation, [mbOk], 0);
{If you want to set the edit and the cell text here do
the following:}
aGrid.EditText := 'Pushed';
aGrid.cells[aGrid.col,aGrid.row] :=  'Pushed';

end;


procedure TForm1.aGridOnSelectCell(Sender: TObject; Col, Row: Longint;
  var CanSelect: Boolean);
begin
{This is were you write your code to make an object appear
according to the cell or column, or row:}

{Here we make a different object appear of each column}
if col = 1 then aGrid.EntryMode := eButtonEdit;
if col = 2 then aGrid.EntryMode := eButton;
if col = 3 then aGrid.EntryMode := eEdit;
if col = 4 then aGrid.EntryMode := eCombo;
if col = 5 then aGrid.EntryMode := eCheckBox;

end;


procedure TForm1.Button2Click(Sender: TObject);
begin
aGrid.ComboBoxEnabled := True;
end;



end.
